bug-gnulib
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

quotearg tests: Avoid test failures on Solaris 11


From: Bruno Haible
Subject: quotearg tests: Avoid test failures on Solaris 11
Date: Fri, 01 Jan 2021 18:24:32 +0100
User-agent: KMail/5.1.3 (Linux/4.4.0-197-generic; KDE/5.18.0; x86_64; ; )

A testdir of modules 'quotearg' and 'gettext' fails on Solaris 11
machines that don't have GNU gettext installed. Specifically on
  - Solaris 11.0, 11.3,
  - Solaris 11 OpenIndiana,
  - Solaris 11 OmniOS.

The reason is that Solaris 11 libc has a gettext() function that
supports GNU .mo files, but it does not look them up in all possible
locations in which we install them. It's fixed in Solaris 11.4.
For OpenIndiana, I've reported it at <https://www.illumos.org/issues/13423>.

This patch provides a workaround.


2021-01-01  Bruno Haible  <bruno@clisp.org>

        quotearg tests: Avoid test failures on Solaris 11.
        * modules/quotearg-tests (Makefile.am): Set host_os in
        TESTS_ENVIRONMENT.
        * tests/test-quotearg.sh: On Solaris 11 systems, make a copy of the fr/
        directory that contains the .mo file.

diff --git a/modules/quotearg-tests b/modules/quotearg-tests
index aed92ce..dc94b34 100644
--- a/modules/quotearg-tests
+++ b/modules/quotearg-tests
@@ -25,6 +25,8 @@ gt_LOCALE_FR_UTF8
 
 Makefile.am:
 TESTS += test-quotearg.sh
-TESTS_ENVIRONMENT += LOCALE_FR='@LOCALE_FR@' LOCALE_FR_UTF8='@LOCALE_FR_UTF8@'
+TESTS_ENVIRONMENT += \
+  LOCALE_FR='@LOCALE_FR@' LOCALE_FR_UTF8='@LOCALE_FR_UTF8@' \
+  host_os='@host_os@'
 check_PROGRAMS += test-quotearg
 test_quotearg_LDADD = $(LDADD) $(LIB_SETLOCALE) @LIBINTL@ $(LIB_MBRTOWC)
diff --git a/tests/test-quotearg.sh b/tests/test-quotearg.sh
index ae33153..b997867 100755
--- a/tests/test-quotearg.sh
+++ b/tests/test-quotearg.sh
@@ -22,5 +22,30 @@ if test $locale = French_France.1252; then
   locale=fr_FR.CP1252
 fi
 
-LOCALE=$locale LOCALEDIR="$srcdir/testlocale" \
+# Work around a bug on Solaris 11 systems with no GNU gettext installed.
+# See gettext/gettext-tools/tests/init.cfg.
+localedir="$srcdir/testlocale"
+if test $locale != none && test $locale != fr; then
+  case "$host_os" in
+    solaris2.11)
+      mkdir -p testlocale
+      cp -a "$srcdir/testlocale/fr" "testlocale/$locale"
+      localedir="testlocale"
+      ;;
+  esac
+fi
+
+LOCALE=$locale LOCALEDIR="$localedir" \
 ${CHECKER} ./test-quotearg${EXEEXT}
+result=$?
+
+if test $locale != none && test $locale != fr; then
+  case "$host_os" in
+    solaris2.11)
+      rm -rf "testlocale/$locale"
+      rmdir testlocale 2>/dev/null
+      ;;
+  esac
+fi
+
+exit $result




reply via email to

[Prev in Thread] Current Thread [Next in Thread]